using System;

using System.Collections.Generic;

using System.IO;

using UnityEngine;

using UnityEngine.Events;

namespace Mod

{

    public class Mod

    {

        public static void Main()

        {

   ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz) MASKA-1SCh",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = " To reduce the weight and cost of MASKA-1, MASKA-1SCh  replaced the glass visor with a slitted steel plate. Later designs made the slit integral to the steel visor. Is able to withstand 9mm pistol, semi automatic pistol,revolver.Everything above is luck or the bullet bounces like in real life ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("maska.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("maska.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz) Groin Protection",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A essential part in every heavy armor",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("botom.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("botom.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "LowerBody";
                        armor.armorTier = 0;
                    }
                }
            );

  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(spetz) Tactical Vest 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A two part tactical vest wit walkie talkie",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("middle.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("middle.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 0;
                    }
                }
            );

  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(spetz) Tactical Vest 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = " The upper part of the tactical vest. has neck protection included ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("top.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("top.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(spetz) Arm Protection 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "To protect the arms from shrapnell.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("toparm.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("toparm.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperArmFront";
                        armor.armorTier = 0;
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(spetz) Arm Protection 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "To protect the arms from shrapnell. ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("toparm2.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("toparm2.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 0;
                    }
                }
            );


 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(spetz) K6-3 Helmet",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A very protective helmet made out of titanium. Tends to swallow the bullets instead of deflect like the maska. can survive a desert eagle bullet easily. ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("k6.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("k6.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(spetz) PMK 2 Gasmask",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A russain military Gasmask ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("pmk.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pmk.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );

  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(spetz) PMG  Gasmask",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A russain military Gasmask pmg ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("pmg.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pmg.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );

  ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz) 6B27 Helemt",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "The russian standard issue Helmet ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("6b47.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("6b47.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(spetz) Russian Navy Shirt 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A blue white striped shirt used by the navy ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("fm.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fm.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 0;
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(spetz) Russian Navy Shirt 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A blue white striped shirt used by the navy ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("fmj.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fmj.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 0;
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(spetz) Russian Navy Shirt 3",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A blue white striped shirt used by the navy ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("fmj0.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fmj0.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "LowerBody";
                        armor.armorTier = 0;
                    }
                }
            );
       ModAPI.Register(new Modification()
      {
        OriginalItem =  ModAPI.FindSpawnable("Rod"),
        NameOverride =  "(spetz) Ballistic Shield",
               DescriptionOverride =  "A very advanced Ballistic Shield used by russian special forces and the alpha group",
        CategoryOverride =  ModAPI.FindCategory("Entities"),
        ThumbnailOverride = ModAPI.LoadSprite("schield.png", 5f, true),
        AfterSpawn =  (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("schield.png", 1f, true);
         Utils.FixColliders(Instance);


                })
      });

             ModAPI.Register(new Modification()
      {
        OriginalItem =  ModAPI.FindSpawnable("AK-47"),
        NameOverride =  "(spetz) PKM",
               DescriptionOverride =  "Used to supress enemys with sheer fire power.",
        CategoryOverride =  ModAPI.FindCategory("Entities"),
        ThumbnailOverride = ModAPI.LoadSprite("pkm.png", 5f, true),
        AfterSpawn =  (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pkm.png", 1f, true);
          Utils.FixColliders(Instance);

                    Instance.GetComponent<FirearmBehaviour>().ShotSounds =  new AudioClip[1]
          {
            ModAPI.LoadSound("vick.mp3")
          };
        })
      });
       
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz) Neck Protection",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "MAKE WEIGHTLESS .A very thick neck protection that can stop small arms fire.  ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("top2.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("top2.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz) Thigh Protection 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A durable thigh protection to protect the werer from bleeding out when an arterie gets hit ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("leg1.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("leg1.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz)  Thigh Protection 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "A durable thigh protection to protect the werer from bleeding out when an arterie gets hit ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("leg1.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("leg1.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperLegFront";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz) Shin Protection 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "To prevent the solider from beeing shot in the shin ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("lowerleg.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lowerleg.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "LowerLegFront";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(spetz)  Shin Protection 1 ",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "To prevent the solider from beeing shot in the shin ",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("lowerleg.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lowerleg.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 0;
                    }
                }
            );





        }

    }

}
